import { Strategy as PassportStrategy } from "passport-strategy";
import type { GetUserResponse } from "@notionhq/client/build/src/api-endpoints";
export declare type NotionPersonUser = Extract<GetUserResponse, {
    type: "person";
}>;
export interface NotionOAuthToken {
    access_token: string;
    token_type: "bearer";
    bot_id: string;
    workspace_id: string;
    workspace_name?: string;
    workspace_icon?: string;
    owner: {
        type: "workspace";
    } | {
        type: "user";
        user: NotionPersonUser;
    };
}
export interface NotionStrategyOptions {
    clientID: string;
    clientSecret: string;
    callbackURL: string;
    tokenURL?: string;
    authorizationURL?: string;
    state?: string;
}
export interface NotionVerifyCallback {
    (req: unknown, // req,
    accessToken: string, // oauthData.access_token,
    _unknown: undefined, // ? undefined,
    oauthData: NotionOAuthToken, // ? Notion OAuth response?
    userProfileData: GetUserResponse, // ? get /v1/users/me response?
    callback: (err: Error | undefined, user: any, info: unknown) => void): void;
}
export default class Strategy extends PassportStrategy {
    name: string;
    private _verify;
    private _options;
    private _clientSecret;
    private _clientID;
    private _tokenURL;
    private _authorizationURL;
    constructor(options: NotionStrategyOptions, verify: NotionVerifyCallback);
    authenticate(req: Parameters<PassportStrategy["authenticate"]>[0], options: Parameters<PassportStrategy["authenticate"]>[1]): Promise<void>;
    getOAuthAccessToken(code: string): Promise<NotionOAuthToken>;
}
//# sourceMappingURL=strategy.d.ts.map